<template>
  <div>
    <div>
<CModal
           title="Info"
      size="sm"
      :show.sync="smallModal">
      {{ SuccessMsg }}

</CModal>


<CCardBody>
     <h5>Trace Material Master</h5>
    
    <CDataTable
      :items="items"
      :fields="fields"
      table-filter
      items-per-page-select
      :items-per-page="5"
      pagination
      hover
      striped
      border
      sorter
     >
   

<!--Adding Customs buttons to each row -->
    <template #show_details="{item}" >
      <CButton size="sm" color="info" class="ml-1"  @click="ShowUpdateModal=true; SelectMaterial(item)"> Update </CButton>
      <CButton size="sm" color="danger" class="ml-1" @click="ShowDeleteModal=true; SelectMaterial(item)" >Delete</CButton>
      <CButton size="sm" color="dark" class="ml-1" @click="ShowDetailsModal=true; SelectMaterial(item)"> Details </CButton>
    </template>

    </CDataTable>
      <CButton size="sm" color="info" class="" @click="ShowAddModal=true"> New Material</CButton>
  </CCardBody>

 </div>
<div id="overlay" v-if="ShowAddModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">

    <h5 class="modal-title"> New Material</h5>
    <button type="button" class="close"  @click="ShowAddModal=false">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-4">
<form action="#" method="POST">

<!-- <div class="form-group">
  <label  >Material Id</label>
<input type="text" name="Material_Id" class="form-control form-control-sm" placeholder="Material Id" v-model="newMaterial.material_Id">
</div> -->

<div class="form-group">
  <label  >Material Code</label>
<input type="text" name="Material_Code" class="form-control form-control-sm"  v-model="newMaterial.material_Code">
</div>

<div class="form-group">
  <label  >Color Code</label>
<input type="text" name="color_Code" class="form-control form-control-sm" placeholder="" v-model="newMaterial.color_Code">
</div>
<div class="form-group">
   <label for="workCent_Id">Work Center</label>
 <select class="form-control" v-model="newMaterial.workCent_Id">
     <option v-for="item in wcitems" :value="item.workCent_Id" :key="item.workCent_Id">{{ item.workCent_Name }} </option>
  </select>
</div>


<!-- <div class="form-group">
  <label  >Production Date</label>
<input type="date" name="material_CreationDate" class="form-control form-control-sm" placeholder="Date"  v-model="newMaterial.materialCreationDate">
</div> -->

<!-- <div class="form-group">
  <label  >Material status</label>
<input type="text" name="status" class="form-control form-control-sm" placeholder="Material status"  v-model="newMaterial.status">
</div> -->

<div class="form-group">
<CButton size="sm" color="info" class=""  @click="ShowAddModal=false;addMaterials();" > Add Material </CButton>
</div>

</form>
 </div>
</div>
</div>
 </div>

<!-- Show Details Modal -->
<div id="overlay" v-if="ShowDetailsModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">
    <h5 class="modal-title">Material Details</h5>
    <button type="button" class="close"  @click="ShowDetailsModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
<div class="modal-body p-4">

<form action="#" method="POST">
<div class="form-group">
  <label  >Material Id</label>
<input type="text" name="Material_Id" readonly class="form-control form-control-sm" placeholder="Material Id" v-model="CurrentMaterial.material_Id">
</div>

<div class="form-group">
  <label  >Material Code</label>
<input type="text" name="Material_Code" readonly class="form-control form-control-sm" placeholder="Material Code" v-model="CurrentMaterial.material_Code">
</div>
<div class="form-group">
  <label  >Color Code</label>
<input type="text" name="color_Code" readonly class="form-control form-control-sm" placeholder="Color code" v-model="CurrentMaterial.color_Code">
</div>
<div class="form-group"><label  >Work Center</label>
<input type="text" name="workCent_Id" readonly class="form-control form-control-sm" placeholder="Work Center Id" v-model="CurrentMaterial.workCenterName">
</div>

<div class="form-group"><label >Date</label>
<input type="text" name="material_CreationDate" readonly class="form-control form-control-sm" placeholder="Material Creation Date"  v-model="CurrentMaterial.materialCreationDate">
</div>

<!-- <div class="form-group"><label  >Ageing Months</label>
<input type="text" name="status" class="form-control form-control-sm" placeholder="Material status"  v-model="newMaterial.status">
</div> -->

<div class="form-group">
<button class="btn btn-info btn-block btn-sm"  @click="ShowDetailsModal=false;" > Close </button>
</div>
</form>

</div>
</div>
</div>
</div>

<!-- Show Update Modal -->
<div id="overlay" v-if="ShowUpdateModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">
    <h5 class="modal-title">Update Material</h5>
    <button type="button" class="close"  @click="ShowUpdateModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-4">
<form action="#" method="POST">
<!-- <div class="form-group"><label  >Material Id</label>
<input type="text" name="Material_Id" readonly class="form-control form-control-sm" placeholder="Material Id" v-model="CurrentMaterial.material_Id">
</div> -->

<div class="form-group"><label  >Material Code</label>
<input type="text" name="Material_Code" class="form-control form-control-sm"  v-model="newMaterial.material_Code">
</div>

<div class="form-group">
  <label  >Color Code</label>
<input type="text" name="color_Code"  class="form-control form-control-sm"  v-model="newMaterial.color_Code">
</div>

<div class="form-group">
   <label for="workCent_Id">Work Center</label>
 <select class="form-control" v-model="newMaterial.workCent_Id">
     <option v-for="item in wcitems" :value="item.workCent_Id" :key="item.workCent_Id">{{ item.workCent_Name }} </option>
  </select>
</div>



<!-- <div class="form-group"><label  >Ageing Months</label>
<input type="text" name="status" class="form-control form-control-sm" placeholder="Material status"  v-model="CurrentMaterial.status">
</div> -->

<div class="form-group">
<button class="btn btn-info btn-block btn-sm"  @click="ShowUpdateModal=false;UpdateMaterials();" > Update Material </button>
</div>
</form>

</div>
</div>
</div>
</div>

<!-- Delete Modal -->
<div id="overlay" v-if="ShowDeleteModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">

    <h5 class="modal-title">Delete Material</h5>
    <button type="button" class="close"  @click="ShowDeleteModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-4">
<h4 class="text-danger"> Are you sure want to delete the material ? </h4>
<h5> You are deleting {{ this.CurrentMaterial.material_Id +' || '+ this.CurrentMaterial.material_Code }}</h5>
<hr>
<button class="btn btn-danger btn-sm" @click="ShowDeleteModal=false; deleteItem();getAllMaterialDetails()  "> Yes </button>
&nbsp;&nbsp;&nbsp;&nbsp;  
<button class="btn btn-success btn-sm" @click="ShowDeleteModal=false"> No </button>
</div>
</div>
</div>
</div>
</div>
</template>

<script>
const apiget =  'Trace_Material_Master/'
const apigetworkcenter = 'Trace_WorkCenter_Master/'
const items = [
  { key: 'material_Id', },
  { key: 'material_Code', },
  { key: 'workCenterName', }, 
  { key: 'color_Code',     },
  //{ key: 'material_CreatedBy',      },
  { key: 'status',     _style: 'width:1%',  },
 ]   

//import CTableWrapper from '.@/Table.vue' 
import Vue from 'vue'
import axios from 'axios'
import VUEAxios from 'vue-axios'
Vue.use(VUEAxios,axios)

export default {
   //components: { CTableWrapper },
  data ()
  {
     return {
    items: items.map((item, id) => { return {...item, id}}),
    
     fields: [
       // { key: 'show_details1',  label: '',  _style: 'width:1%', },
            
              { key: 'material_Id' , label: ' Id', _style: 'width:3%',},
              { key: 'material_Code', label: 'Material Code',  _style: 'width:20%',},
              { key: 'color_Code',  label: ' Color Code',  _style: 'width:22%', },
              { key: 'workCenterName', label: 'Work Center ', _style: 'width:10%',},             
              { key: 'show_details',  label: '',  _style: 'width:30%', },
             // { key: 'material_CreationDate',  label: 'Date',  _style: 'width:22%', },
             // { key: 'material_CreatedBy',  label: 'Material CreatedBy',  _style: 'width:12%', },
             // { key: 'status',  label: 'Status',  _style: 'width:12%', },
                    
      ],

  details: [],
  collapseDuration: 0,
  errMsg:"",
  SuccessMsg:"",
  ShowAddModal:"",
  ShowDeleteModal:"",
  CurrentMaterial:"",
  ShowUpdateModal:"",
  ShowDetailsModal:"",
  smallModal: false,
  newMaterial: {material_Id:0,material_Code:"",color_Code :"",workCent_Id:0,material_Type:"",material_CreationDate: new Date().toISOString().slice(0,10),material_CreatedBy:"",status:1,}, }
  },
 

  
  mounted()
  {
   this.getAllMaterialDetails();
   this.getAllWorkCenter();
  },

  methods:
  {
   getAllMaterialDetails: function()
   {
 
   Vue.axios.get(this.$url + apiget)
    .then((response)=>{
    if(response.data.error)
       {
         this.errMsg=response.data.message;
       }
    else
       {
        this.items =response.data.filter(x => x.status == 1);
      
       }
    });
   },
  getAllWorkCenter: function()
   {

   Vue.axios.get(this.$url + apigetworkcenter)
    .then((response)=>{
    if(response.data.error)
       {
         this.errMsg=response.data.message;
       }
    else
       {
        this.wcitems =response.data.filter(x => x.status == 1);
      
       }
    });
   },

   
  addMaterials()
  {
if(this.newMaterial.material_Code == "" || this.newMaterial.workCent_Id== 0 || this.newMaterial.color_Code == "" )

{
  this.SuccessMsg = "Please enter all fields";
  this.smallModal = true;
  this.ShowAddModal = true;
    

}
 else if(this.items.find(x => x.material_Code == this.newMaterial.material_Code && x.status == 1 ))
     {
       this.SuccessMsg= "Material Code " + this.newMaterial.material_Code +" already exist. Please try another Name";
       this.smallModal = true;
        this.ShowAddModal = true;
      }
    
    else
     {
      
       Vue.axios.post(this.$url + apiget ,this.newMaterial).then((response)=>{
       if(response.data.error)
       {
          alert('Data Error')
       }
       else
       {
        this.SuccessMsg ="Records Inserted Successfully.."
        location.reload();
       this.getAllMaterialDetails();
       }
      })
     }
   },

  UpdateMaterials()
  {

   if((this.CurrentMaterial.material_Code != this.newMaterial.material_Code ) && this.items.find(x => x.material_Code == this.newMaterial.material_Code && x.status == 1 ))
      {
       this.SuccessMsg= "Material Code " + this.newMaterial.material_Code +" already exist. ";
       this.smallModal = true;
     }
   
     else if(this.newMaterial.color_Code == "" || this.newMaterial.material_Code == "" || this.newMaterial.workCent_Id== 0 )
    {

    this.SuccessMsg = "Please enter all the fields";
    this.smallModal = true;
    }
    else
     {

      this.newMaterial.material_Id =  this.CurrentMaterial.material_Id;
      Vue.axios.put(this.$url + apiget + this.CurrentMaterial.material_Id,this.newMaterial).then((response)=>{
       if(response.data.error)
       {
          alert('Data Error')
       }
       else
       {
         this.SuccessMsg ="Records Updated Successfully.."
         this.getAllMaterialDetails();
       }
    })
     }
   },

  deleteItem()
    {
      var material_Id = this.CurrentMaterial.material_Id;
         axios({   method: 'delete',
           url: this.$url + apiget+ material_Id
    });
        this.SuccessMsg="Material Status Changed to Inactive Succesfully"
        this.smallModal = true;
        this.getAllMaterialDetails();
        location.reload();
    },
      
  SelectMaterial(Material)
    {
     this.CurrentMaterial=Material;
    },
 
 
    
    },
  
    

}
</script>

<style scoped>
#overlay{
  position:fixed;
  top:100px;
  bottom:0;
  left:0;
  right:0;
  background:rgba(0,0,0,0.6);
}
</style>